/*
Copyright 2020 VMware, Inc.
SPDX-License-Identifier: Apache-2.0
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/suzerain-io/placeholder-name/kubernetes/1.19/api/apis/crdsplaceholder/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeLoginDiscoveryConfigs implements LoginDiscoveryConfigInterface
type FakeLoginDiscoveryConfigs struct {
	Fake *FakeCrdsV1alpha1
	ns   string
}

var logindiscoveryconfigsResource = schema.GroupVersionResource{Group: "crds.placeholder.suzerain-io.github.io", Version: "v1alpha1", Resource: "logindiscoveryconfigs"}

var logindiscoveryconfigsKind = schema.GroupVersionKind{Group: "crds.placeholder.suzerain-io.github.io", Version: "v1alpha1", Kind: "LoginDiscoveryConfig"}

// Get takes name of the loginDiscoveryConfig, and returns the corresponding loginDiscoveryConfig object, and an error if there is any.
func (c *FakeLoginDiscoveryConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(logindiscoveryconfigsResource, c.ns, name), &v1alpha1.LoginDiscoveryConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LoginDiscoveryConfig), err
}

// List takes label and field selectors, and returns the list of LoginDiscoveryConfigs that match those selectors.
func (c *FakeLoginDiscoveryConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LoginDiscoveryConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(logindiscoveryconfigsResource, logindiscoveryconfigsKind, c.ns, opts), &v1alpha1.LoginDiscoveryConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.LoginDiscoveryConfigList{ListMeta: obj.(*v1alpha1.LoginDiscoveryConfigList).ListMeta}
	for _, item := range obj.(*v1alpha1.LoginDiscoveryConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested loginDiscoveryConfigs.
func (c *FakeLoginDiscoveryConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(logindiscoveryconfigsResource, c.ns, opts))

}

// Create takes the representation of a loginDiscoveryConfig and creates it.  Returns the server's representation of the loginDiscoveryConfig, and an error, if there is any.
func (c *FakeLoginDiscoveryConfigs) Create(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.CreateOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(logindiscoveryconfigsResource, c.ns, loginDiscoveryConfig), &v1alpha1.LoginDiscoveryConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LoginDiscoveryConfig), err
}

// Update takes the representation of a loginDiscoveryConfig and updates it. Returns the server's representation of the loginDiscoveryConfig, and an error, if there is any.
func (c *FakeLoginDiscoveryConfigs) Update(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.UpdateOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(logindiscoveryconfigsResource, c.ns, loginDiscoveryConfig), &v1alpha1.LoginDiscoveryConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LoginDiscoveryConfig), err
}

// Delete takes name of the loginDiscoveryConfig and deletes it. Returns an error if one occurs.
func (c *FakeLoginDiscoveryConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(logindiscoveryconfigsResource, c.ns, name), &v1alpha1.LoginDiscoveryConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLoginDiscoveryConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(logindiscoveryconfigsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.LoginDiscoveryConfigList{})
	return err
}

// Patch applies the patch and returns the patched loginDiscoveryConfig.
func (c *FakeLoginDiscoveryConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(logindiscoveryconfigsResource, c.ns, name, pt, data, subresources...), &v1alpha1.LoginDiscoveryConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LoginDiscoveryConfig), err
}
