/*
Copyright 2020 VMware, Inc.
SPDX-License-Identifier: Apache-2.0
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/suzerain-io/placeholder-name/kubernetes/1.19/api/apis/crdsplaceholder/v1alpha1"
	scheme "github.com/suzerain-io/placeholder-name/kubernetes/1.19/client-go/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// LoginDiscoveryConfigsGetter has a method to return a LoginDiscoveryConfigInterface.
// A group's client should implement this interface.
type LoginDiscoveryConfigsGetter interface {
	LoginDiscoveryConfigs(namespace string) LoginDiscoveryConfigInterface
}

// LoginDiscoveryConfigInterface has methods to work with LoginDiscoveryConfig resources.
type LoginDiscoveryConfigInterface interface {
	Create(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.CreateOptions) (*v1alpha1.LoginDiscoveryConfig, error)
	Update(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.UpdateOptions) (*v1alpha1.LoginDiscoveryConfig, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.LoginDiscoveryConfig, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.LoginDiscoveryConfigList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LoginDiscoveryConfig, err error)
	LoginDiscoveryConfigExpansion
}

// loginDiscoveryConfigs implements LoginDiscoveryConfigInterface
type loginDiscoveryConfigs struct {
	client rest.Interface
	ns     string
}

// newLoginDiscoveryConfigs returns a LoginDiscoveryConfigs
func newLoginDiscoveryConfigs(c *CrdsV1alpha1Client, namespace string) *loginDiscoveryConfigs {
	return &loginDiscoveryConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the loginDiscoveryConfig, and returns the corresponding loginDiscoveryConfig object, and an error if there is any.
func (c *loginDiscoveryConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	result = &v1alpha1.LoginDiscoveryConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of LoginDiscoveryConfigs that match those selectors.
func (c *loginDiscoveryConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LoginDiscoveryConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.LoginDiscoveryConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested loginDiscoveryConfigs.
func (c *loginDiscoveryConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a loginDiscoveryConfig and creates it.  Returns the server's representation of the loginDiscoveryConfig, and an error, if there is any.
func (c *loginDiscoveryConfigs) Create(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.CreateOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	result = &v1alpha1.LoginDiscoveryConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(loginDiscoveryConfig).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a loginDiscoveryConfig and updates it. Returns the server's representation of the loginDiscoveryConfig, and an error, if there is any.
func (c *loginDiscoveryConfigs) Update(ctx context.Context, loginDiscoveryConfig *v1alpha1.LoginDiscoveryConfig, opts v1.UpdateOptions) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	result = &v1alpha1.LoginDiscoveryConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		Name(loginDiscoveryConfig.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(loginDiscoveryConfig).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the loginDiscoveryConfig and deletes it. Returns an error if one occurs.
func (c *loginDiscoveryConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *loginDiscoveryConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched loginDiscoveryConfig.
func (c *loginDiscoveryConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LoginDiscoveryConfig, err error) {
	result = &v1alpha1.LoginDiscoveryConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("logindiscoveryconfigs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
