/*
Copyright 2020 VMware, Inc.
SPDX-License-Identifier: Apache-2.0
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/suzerain-io/placeholder-name/kubernetes/1.19/api/apis/placeholder/v1alpha1"
	"github.com/suzerain-io/placeholder-name/kubernetes/1.19/client-go/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type PlaceholderV1alpha1Interface interface {
	RESTClient() rest.Interface
	LoginRequestsGetter
}

// PlaceholderV1alpha1Client is used to interact with features provided by the placeholder.suzerain-io.github.io group.
type PlaceholderV1alpha1Client struct {
	restClient rest.Interface
}

func (c *PlaceholderV1alpha1Client) LoginRequests() LoginRequestInterface {
	return newLoginRequests(c)
}

// NewForConfig creates a new PlaceholderV1alpha1Client for the given config.
func NewForConfig(c *rest.Config) (*PlaceholderV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &PlaceholderV1alpha1Client{client}, nil
}

// NewForConfigOrDie creates a new PlaceholderV1alpha1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *PlaceholderV1alpha1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new PlaceholderV1alpha1Client for the given RESTClient.
func New(c rest.Interface) *PlaceholderV1alpha1Client {
	return &PlaceholderV1alpha1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1alpha1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *PlaceholderV1alpha1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
