/*
Copyright 2020 VMware, Inc.
SPDX-License-Identifier: Apache-2.0
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	crdsplaceholderv1alpha1 "github.com/suzerain-io/placeholder-name/kubernetes/1.19/api/apis/crdsplaceholder/v1alpha1"
	versioned "github.com/suzerain-io/placeholder-name/kubernetes/1.19/client-go/clientset/versioned"
	internalinterfaces "github.com/suzerain-io/placeholder-name/kubernetes/1.19/client-go/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/suzerain-io/placeholder-name/kubernetes/1.19/client-go/listers/crdsplaceholder/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// LoginDiscoveryConfigInformer provides access to a shared informer and lister for
// LoginDiscoveryConfigs.
type LoginDiscoveryConfigInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.LoginDiscoveryConfigLister
}

type loginDiscoveryConfigInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewLoginDiscoveryConfigInformer constructs a new informer for LoginDiscoveryConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewLoginDiscoveryConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredLoginDiscoveryConfigInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredLoginDiscoveryConfigInformer constructs a new informer for LoginDiscoveryConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredLoginDiscoveryConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.CrdsV1alpha1().LoginDiscoveryConfigs(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.CrdsV1alpha1().LoginDiscoveryConfigs(namespace).Watch(context.TODO(), options)
			},
		},
		&crdsplaceholderv1alpha1.LoginDiscoveryConfig{},
		resyncPeriod,
		indexers,
	)
}

func (f *loginDiscoveryConfigInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredLoginDiscoveryConfigInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *loginDiscoveryConfigInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&crdsplaceholderv1alpha1.LoginDiscoveryConfig{}, f.defaultInformer)
}

func (f *loginDiscoveryConfigInformer) Lister() v1alpha1.LoginDiscoveryConfigLister {
	return v1alpha1.NewLoginDiscoveryConfigLister(f.Informer().GetIndexer())
}
